package org.vamsas.test.simpleclient;

import java.io.File;
import java.util.Iterator;
import java.util.Vector;

import org.vamsas.client.ClientHandle;
import org.vamsas.client.simpleclient.ClientsFile;
import org.vamsas.client.simpleclient.FileWatcher;

public class ClientsFileTest {
  private static Vector commands;
  static {
    ClientsFileTest.commands=new Vector();
    ClientsFileTest.commands.add(new String("add"));
    ClientsFileTest.commands.add(new String("remove"));
    ClientsFileTest.commands.add(new String("list"));    
    ClientsFileTest.commands.add(new String("clear"));
    ClientsFileTest.commands.add(new String("watch"));    
  }
  private static void complainArgs(int argl, int argpos, String cmd, int argneed, String msg) {
    if (argl-argpos<argneed)
      throw new Error(cmd+" needs "+argneed+" arguments : "+msg);
  }
  public static void main(String[] args) {
    java.io.File cf = new java.io.File(args[0]);
    System.out.println("Connecting to clientFile "+args[0]);
    ClientsFile cfhand;
    try {
      cfhand = new ClientsFile(cf);
    }
    catch (Exception e) {
      e.printStackTrace(System.err);
      return;
    }
    int argc=1;
    while (argc<args.length) {
      Iterator coms = commands.iterator();
      int com=-1;
      while ((coms!=null) && coms.hasNext()) {
        com++;
        if (args[argc].toLowerCase().equals((String) coms.next())) {
          System.out.println("Doing "+args[argc]);
          ClientHandle ch;
          argc++;
          switch (com) {
          case 0:
            // Add
            ClientsFileTest.complainArgs(args.length, argc, "add", 2, "for the Client's 'Name' and 'Version'");
            int pos = cfhand.addClient(ch=new ClientHandle(args[argc],args[argc+1]));
            argc+=2;
            if (pos!=0)
              System.out.println("Client added at "+pos+" as urn:"+ch.getClientUrn());
            else
              System.out.println("Client was not added.");
            break;
          case 1:
            // remove
            ClientsFileTest.complainArgs(args.length, argc, "remove", 3, "for the Client's 'Name', Version and URN");
            ch=new ClientHandle(args[argc], args[argc+1]);
            ch.setClientUrn(args[argc+2]);
            argc+=3;
            cfhand.removeClient(ch);
            System.out.println("Client removed (apparently)");
            break;
          case 2:
            // list
            ClientHandle[] chlist = cfhand.retrieveClientList();
            if (chlist!=null) {
              for (int chi=0,che=chlist.length; chi<che; chi++) {
                System.out.println("Client "+chi+" ("+chlist[chi].getClientName()+" "+chlist[chi].getVersion()+" "+chlist[chi].getClientUrn()+")");
              }
            } else {
              System.out.println("Client list is empty.");
            }
            break;
          case 3:
            // clear
            cfhand = null;
            cf.delete();
            try {
              cf.createNewFile();
              cfhand = new ClientsFile(cf);
            }
            catch (Exception e) {
              System.err.println("Failed on new empty clientfile creation!");
              e.printStackTrace(System.err);
            }
            break;
          case 4:
            // watch
            FileWatcher w=new FileWatcher(cf);
            while (cf.exists()) {
              if (w.hasChanged()) {
                ClientHandle[] cl = cfhand.retrieveClientList();
                System.out.println("-- Watching "+cf.getName());
                //while (w.hasChanged())
                //  ;
                if (cl!=null) {
                  for (int chi=0,che=cl.length; chi<che; chi++) {
                    System.out.println("Client "+chi+" ("+cl[chi].getClientName()+" "+cl[chi].getVersion()+" "+cl[chi].getClientUrn()+")");
                  }
                } else {
                  System.out.println("Client list is empty.");
                }
              }
              
            }
            
          }
          coms = null;
        }
      }
      if (coms!=null) {
        System.err.println("Unknown command : "+args[argc++] + "*Ignored!*");
      };
      for (int j=0; j<900000; j++)
        ;
    }
  }

}
